%?mingw_package_header

%global qt_module qtsystems
#%%global pre beta1

%global snapshot_date 20130510
%global snapshot_rev fb72a057

%if 0%{?snapshot_date}
%global source_folder qt-%{qt_module}
%else
%global source_folder %{qt_module}-opensource-src-%{version}%{?pre:-%{pre}}
%endif

Name:           mingw-qt5-%{qt_module}
Version:        5.0.0
Release:        0.7%{?pre:.%{pre}}%{?snapshot_date:.git%{snapshot_date}.%{snapshot_rev}}%{?dist}
Summary:        Qt5 for Windows - QtSystems component

License:        GPLv3 with exceptions or LGPLv2 with exceptions
Group:          Development/Libraries
URL:            http://www.qtsoftware.com/

%if 0%{?snapshot_date}
# To regenerate:
# wget http://qt.gitorious.org/qt/%{qt_module}/archive-tarball/%{snapshot_rev} -O qt5-%{qt_module}-%{snapshot_rev}.tar.gz
Source0:        qt5-%{qt_module}-%{snapshot_rev}.tar.gz
%else
Source0:        http://releases.qt-project.org/qt5/%{version}/submodules/%{qt_module}-opensource-src-%{version}%{?pre:-%{pre}}.tar.xz
%endif

BuildArch:      noarch

BuildRequires:  mingw32-filesystem >= 96
BuildRequires:  mingw32-gcc-c++
BuildRequires:  mingw32-qt5-qtbase
BuildRequires:  mingw32-qt5-qtdeclarative
BuildRequires:  mingw32-GConf2

BuildRequires:  mingw64-filesystem >= 96
BuildRequires:  mingw64-gcc-c++
BuildRequires:  mingw64-qt5-qtbase
BuildRequires:  mingw64-qt5-qtdeclarative
BuildRequires:  mingw64-GConf2

# Don't use case-sensitive file names in #include's
Patch0:         qt5-qtsystems-fix-case-sensitive-includes.patch

# Don't use case-sensitive library names when linking
Patch1:         qt5-qtsystems-link-against-correct-win32-libs.patch

# Compile fix which is related to lambda constructions and started to appear as of Qt 5.1
Patch2:         qt5-qtsystems-compile-fix.patch


%description
This package contains the Qt software toolkit for developing
cross-platform applications.

This is the Windows version of Qt, for use in conjunction with the
Fedora Windows cross-compiler.


# Win32
%package -n mingw32-qt5-%{qt_module}
Summary:        Qt5 for Windows - QtSystems component

%description -n mingw32-qt5-%{qt_module}
This package contains the Qt software toolkit for developing
cross-platform applications.

This is the Windows version of Qt, for use in conjunction with the
Fedora Windows cross-compiler.


# Win64
%package -n mingw64-qt5-%{qt_module}
Summary:        Qt5 for Windows - QtSystems component

%description -n mingw64-qt5-%{qt_module}
This package contains the Qt software toolkit for developing
cross-platform applications.

This is the Windows version of Qt, for use in conjunction with the
Fedora Windows cross-compiler.


%?mingw_debug_package


%prep
%setup -q -n %{source_folder}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%if 0%{?snapshot_date}
# Make sure the syncqt tool is run because we're using a git snapshot
# Otherwise the build fails against Qt 5.1
mkdir .git
%endif


%build
%mingw_qmake_qt5 ../%{qt_module}.pro
%mingw_make %{?_smp_mflags}


%install
%mingw_make install INSTALL_ROOT=$RPM_BUILD_ROOT

# .prl files aren't interesting for us
find $RPM_BUILD_ROOT -name "*.prl" -delete

# Rename the .a files to .dll.a as they're actually import libraries and not static libraries
for FN in $RPM_BUILD_ROOT%{mingw32_libdir}/*.a $RPM_BUILD_ROOT%{mingw64_libdir}/*.a ; do
    FN_NEW=$(echo $FN | sed s/'.a$'/'.dll.a'/)
    mv $FN $FN_NEW
done

# The .dll's are installed in both %%{mingw32_bindir} and %%{mingw32_libdir}
# One copy of the .dll's is sufficient
rm -f $RPM_BUILD_ROOT%{mingw32_libdir}/*.dll
rm -f $RPM_BUILD_ROOT%{mingw64_libdir}/*.dll


# Win32
%files -n mingw32-qt5-%{qt_module}
%{mingw32_bindir}/Qt0PublishSubscribe.dll
%{mingw32_bindir}/Qt0ServiceFramework.dll
%{mingw32_bindir}/Qt0SystemInfo.dll
%{mingw32_bindir}/servicefw.exe
%{mingw32_bindir}/sfwlisten.exe
%{mingw32_includedir}/qt5/QtPublishSubscribe/
%{mingw32_includedir}/qt5/QtServiceFramework/
%{mingw32_includedir}/qt5/QtSystemInfo/
%{mingw32_libdir}/libQt0PublishSubscribe.dll.a
%{mingw32_libdir}/libQt0ServiceFramework.dll.a
%{mingw32_libdir}/libQt0SystemInfo.dll.a
%{mingw32_libdir}/cmake/Qt5PublishSubscribe/
%{mingw32_libdir}/cmake/Qt5ServiceFramework/
%{mingw32_libdir}/cmake/Qt5SystemInfo/
%{mingw32_libdir}/pkgconfig/Qt0PublishSubscribe.pc
%{mingw32_libdir}/pkgconfig/Qt0ServiceFramework.pc
%{mingw32_libdir}/pkgconfig/Qt0SystemInfo.pc
%dir %{mingw32_datadir}/qt5/qml/QtPublishSubscribe/
%{mingw32_datadir}/qt5/qml/QtPublishSubscribe/declarative_publishsubscribe.dll
%{mingw32_datadir}/qt5/qml/QtPublishSubscribe/plugins.qmltypes
%{mingw32_datadir}/qt5/qml/QtPublishSubscribe/qmldir
%dir %{mingw32_datadir}/qt5/qml/QtServiceFramework/
%{mingw32_datadir}/qt5/qml/QtServiceFramework/declarative_serviceframework.dll
%{mingw32_datadir}/qt5/qml/QtServiceFramework/plugins.qmltypes
%{mingw32_datadir}/qt5/qml/QtServiceFramework/qmldir
%dir %{mingw32_datadir}/qt5/qml/QtSystemInfo/
%{mingw32_datadir}/qt5/qml/QtSystemInfo/declarative_systeminfo.dll
%{mingw32_datadir}/qt5/qml/QtSystemInfo/plugins.qmltypes
%{mingw32_datadir}/qt5/qml/QtSystemInfo/qmldir
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_publishsubscribe.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_serviceframework.pri
%{mingw32_datadir}/qt5/mkspecs/modules/qt_lib_systeminfo.pri

# Win64
%files -n mingw64-qt5-%{qt_module}
%{mingw64_bindir}/Qt0PublishSubscribe.dll
%{mingw64_bindir}/Qt0ServiceFramework.dll
%{mingw64_bindir}/Qt0SystemInfo.dll
%{mingw64_bindir}/servicefw.exe
%{mingw64_bindir}/sfwlisten.exe
%{mingw64_includedir}/qt5/QtPublishSubscribe/
%{mingw64_includedir}/qt5/QtServiceFramework/
%{mingw64_includedir}/qt5/QtSystemInfo/
%{mingw64_libdir}/libQt0PublishSubscribe.dll.a
%{mingw64_libdir}/libQt0ServiceFramework.dll.a
%{mingw64_libdir}/libQt0SystemInfo.dll.a
%{mingw64_libdir}/cmake/Qt5PublishSubscribe/
%{mingw64_libdir}/cmake/Qt5ServiceFramework/
%{mingw64_libdir}/cmake/Qt5SystemInfo/
%{mingw64_libdir}/pkgconfig/Qt0PublishSubscribe.pc
%{mingw64_libdir}/pkgconfig/Qt0ServiceFramework.pc
%{mingw64_libdir}/pkgconfig/Qt0SystemInfo.pc
%dir %{mingw64_datadir}/qt5/qml/QtPublishSubscribe/
%{mingw64_datadir}/qt5/qml/QtPublishSubscribe/declarative_publishsubscribe.dll
%{mingw64_datadir}/qt5/qml/QtPublishSubscribe/plugins.qmltypes
%{mingw64_datadir}/qt5/qml/QtPublishSubscribe/qmldir
%dir %{mingw64_datadir}/qt5/qml/QtServiceFramework/
%{mingw64_datadir}/qt5/qml/QtServiceFramework/declarative_serviceframework.dll
%{mingw64_datadir}/qt5/qml/QtServiceFramework/plugins.qmltypes
%{mingw64_datadir}/qt5/qml/QtServiceFramework/qmldir
%dir %{mingw64_datadir}/qt5/qml/QtSystemInfo/
%{mingw64_datadir}/qt5/qml/QtSystemInfo/declarative_systeminfo.dll
%{mingw64_datadir}/qt5/qml/QtSystemInfo/plugins.qmltypes
%{mingw64_datadir}/qt5/qml/QtSystemInfo/qmldir
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_publishsubscribe.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_serviceframework.pri
%{mingw64_datadir}/qt5/mkspecs/modules/qt_lib_systeminfo.pri


%changelog
* Wed Jul 31 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.7.git20130510.fb72a057
- Added BR: mingw{32,64}-GConf2
- Don't bundle .dll.debug files in the main packages

* Tue Jul 23 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.6.git20130510.fb72a057
- Fix FTBFS which started to appear with Qt 5.1

* Thu Jul 18 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.5.git20130510.fb72a057
- Make sure the syncqt tool is run because we're using a git snapshot

* Fri May 10 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.4.git20130510.fb72a057
- Update to 20130510 snapshot (rev fb72a057)

* Fri Jan 11 2013 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.3.git20121112.511d739c
- Fix filelist

* Mon Nov 12 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.2.beta1.git20121112.511d739c
- Update to 20121112 snapshot (rev 511d739c)
- Rebuild against latest mingw-qt5-qtbase
- Dropped pkg-config rename hack as it's unneeded now

* Thu Sep 13 2012 Erik van Pienbroek <epienbro@fedoraproject.org> - 5.0.0-0.1.beta1
- Initial release

